
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************   1. May 2006  18:51  *************

	processor  16F877
	radix  DEC

	EXTERN GLCD_DATA_ZEICHEN
Carry       EQU   0
RP0         EQU   5
RP1         EQU   6

BANK0    UDATA
_LcJA       RES   3
  GLOBAL _LcJA
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
RD          EQU   0
EEPGD       EQU   7

  ; FILE GLCD_FONT5X7.C
			;/****************************************************************************************/
			;/* Unterprogramme zur Ansteuerung des Grafik-LCD (mit SED1520-Controller) in C (CC5X)	*/
			;/* (Font 5x7)																			*/
			;/*																						*/
			;/* Entwickler: Buchgeher Stefan															*/
			;/* Entwicklungsbeginn der Software: 5. Maerz 2006										*/
			;/* Funktionsfaehig seit: 2. April 2006 					 							    */
			;/* Letzte Bearbeitung: 10. April 2006													*/
			;/****************************************************************************************/
			;
			;/****************** Projekt-Header einbinden ********************************************/
			;#include "PROJEKT.H"
			; 
			;
			;/****************** Unterprogramme zur Grafik-LCD-Ansteuerung ***************************/
			;
			;/****************************************************************************************/
			;/* GLCD_ZEICHEN_5x7  									     							*/
			;/*                                                                                      */
			;/* Aufgabe:                                                                             */
			;/*	 Ein Zeichen (Character im Format 5x7) am Grafik-LC-Display ausgeben			    */
			;/*                                                                                      */
			;/* Uebergabeparameter:                                                                  */
			;/*   zeichen (im ASCII-Format)			                                                */
			;/*																						*/
			;/* Rueckgabeparameter:                                                                  */
			;/*   keiner																				*/
			;/*                                                                                      */
			;/* Vorgehensweise:                                                                      */
			;/*	 Nacheinander die Spalten eines Zeichens an das Grafik-LC-Display mit dem Unter-	*/
			;/*   programm GLCD_DATA_ZEICHEN uebergeben. Die Daten fuer die Spalten sind in 		    */
			;/*	 Tabellen abgelegt, wobei fuer jede Spalte des Zeichens eine eigene Tabelle vor-	*/
			;/*	 handen ist. Diese Tabellen muessen an anderer Stelle hinzugefuegt werden! Die 		*/
			;/*	 letzte Spalte muss eine 0 enthalten, also eine "Leerspalte".						*/
			;/****************************************************************************************/
			;void GLCD_ZEICHEN_5x7(unsigned char zeichen)
			;{

PROG1   CODE
_const1
	BCF   0x03,RP0
	BCF   0x03,RP1
	RRF   _LcJA+2,W
	ADDLW HIGH(cwdata1)
	BSF   0x03,RP1
	MOVWF EEADRH
	BCF   0x03,RP1
	RRF   _LcJA+2,W
	RRF   _LcJA+1,W
	ADDLW LOW(cwdata1)
	BSF   0x03,RP1
	MOVWF EEADR
	BTFSS 0x03,Carry
	GOTO  m001
	INCF  EEADRH,1
m001	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
	BSF   0x18C,RD
	NOP  
	NOP  
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSC _LcJA+1,0
	GOTO  m002
	BSF   0x03,RP1
	MOVF  EEDATA,W
	ANDLW .127
	RETURN
m002	BCF   0x03,RP0
	BSF   0x03,RP1
	RLF   EEDATA,W
	RLF   EEDATH,W
	RETURN
cwdata1
	DW    0x3E
	DW    0x10C2
	DW    0x1398
	DW    0xBC
	DW    0x336
	DW    0x3FFE
	DW    0x3FBE
	DW    0x3FFF
	DW    0x1079
	DW    0x1E38
	DW    0x7E
	DW    0x0
	DW    0xAC8
	DW    0x14
	DW    0x247C
	DW    0x804
	DW    0x0
	DW    0xA00
	DW    0x11A4
	DW    0x36
	DW    0x0
	DW    0x414
	DW    0x400
	DW    0x1000
	DW    0x3E
	DW    0x10C2
	DW    0x1398
	DW    0xBC
	DW    0x336
	DW    0x0
	DW    0xA08
	DW    0x141
	DW    0x3F32
	DW    0x1F7F
	DW    0x3FFF
	DW    0x1F7F
	DW    0x7F
	DW    0x3FA0
	DW    0x3FFF
	DW    0x1F7F
	DW    0x1F7F
	DW    0x137F
	DW    0x1F81
	DW    0x3F87
	DW    0x3E3
	DW    0x61
	DW    0x2
	DW    0x2004
	DW    0x1000
	DW    0x1C7F
	DW    0x1C38
	DW    0x608
	DW    0x7F
	DW    0x20
	DW    0x3C00
	DW    0x1C7C
	DW    0x47C
	DW    0x247C
	DW    0x1E02
	DW    0x1E1C
	DW    0x644
	DW    0x444
	DW    0x0
	DW    0x408
	DW    0x2151
	DW    0x20E1
	DW    0x2294
	DW    0xCA
	DW    0x24C9
	DW    0x2491
	DW    0x20C1
	DW    0x4C9
	DW    0x2AA4
	DW    0x20C5
	DW    0x1
	DW    0x0
	DW    0xB7E
	DW    0x3BE
	DW    0x2410
	DW    0x1002
	DW    0x0
	DW    0x3F87
	DW    0x9AA
	DW    0x2C9
	DW    0x209C
	DW    0x408
	DW    0x450
	DW    0x860
	DW    0x2151
	DW    0x20E1
	DW    0x2294
	DW    0xCA
	DW    0x24C9
	DW    0x2B36
	DW    0xA14
	DW    0xA2
	DW    0x8C9
	DW    0x20C9
	DW    0x24C1
	DW    0x2089
	DW    0x2088
	DW    0x440
	DW    0x140
	DW    0x2084
	DW    0x2089
	DW    0x2489
	DW    0x2001
	DW    0x1018
	DW    0x414
	DW    0x3FD1
	DW    0x2084
	DW    0x2002
	DW    0x2A01
	DW    0x2248
	DW    0x2A44
	DW    0x297E
	DW    0x2408
	DW    0x3FC0
	DW    0x241
	DW    0x2208
	DW    0xA14
	DW    0x2A08
	DW    0x203F
	DW    0x2020
	DW    0x2828
	DW    0x1B64
	DW    0x2080
	DW    0xE08
	DW    0x3FC9
	DW    0x22D1
	DW    0x2292
	DW    0x3CC9
	DW    0x24C9
	DW    0x2491
	DW    0x20C1
	DW    0x4C9
	DW    0x2A22
	DW    0x2044
	DW    0x25
	DW    0x0
	DW    0x3E49
	DW    0x2D5
	DW    0x3F20
	DW    0x3FFF
	DW    0x2F80
	DW    0xA00
	DW    0x47F
	DW    0x1D5
	DW    0x1122
	DW    0x1F3E
	DW    0x430
	DW    0x460
	DW    0x3FC9
	DW    0x22D1
	DW    0x2292
	DW    0x3CC9
	DW    0x24C9
	DW    0x1B36
	DW    0xA22
	DW    0x2894
	DW    0x8F9
	DW    0x20C9
	DW    0x24C1
	DW    0x2489
	DW    0x3F88
	DW    0xA41
	DW    0x640
	DW    0x2088
	DW    0x2889
	DW    0x2499
	DW    0x207F
	DW    0xC60
	DW    0x3808
	DW    0x20C9
	DW    0x2088
	DW    0x2001
	DW    0x2A02
	DW    0x2244
	DW    0x2A44
	DW    0x2909
	DW    0x3D04
	DW    0x844
	DW    0xC7F
	DW    0x2204
	DW    0xA14
	DW    0x2A04
	DW    0x2042
	DW    0x1840
	DW    0x2810
	DW    0x20D4
	DW    0x20FF
	DW    0x152A
	DW    0x2045
	DW    0x25C9
	DW    0x22FF
	DW    0x2C9
	DW    0x14C9
	DW    0x2491
	DW    0x1141
	DW    0x4C9
	DW    0x2AA4
	DW    0x20C5
	DW    0x25
	DW    0x0
	DW    0xB41
	DW    0x3D5
	DW    0x2420
	DW    0x1002
	DW    0x0
	DW    0x3F87
	DW    0x322A
	DW    0x22
	DW    0xE41
	DW    0x408
	DW    0x400
	DW    0x200
	DW    0x2045
	DW    0x25C9
	DW    0x22FF
	DW    0x2C9
	DW    0x14C9
	DW    0x0
	DW    0xA41
	DW    0x488
	DW    0x8C1
	DW    0x20C9
	DW    0x24A2
	DW    0x2489
	DW    0x2088
	DW    0x113F
	DW    0x140
	DW    0x2090
	DW    0x1089
	DW    0x24A9
	DW    0x2001
	DW    0x1018
	DW    0x414
	DW    0x20C5
	DW    0x3F90
	DW    0x2002
	DW    0x2A04
	DW    0x2244
	DW    0x2A48
	DW    0x2901
	DW    0x2004
	DW    0x143D
	DW    0x240
	DW    0x2204
	DW    0xA14
	DW    0x2A04
	DW    0x1040
	DW    0x2020
	DW    0x2828
	DW    0x20CC
	DW    0x1B00
	DW    0x41C
	DW    0x3E
	DW    0x18C6
	DW    0x1C90
	DW    0x1B0
	DW    0xF36
	DW    0x1B7E
	DW    0xE22
	DW    0xC1
	DW    0x3C79
	DW    0x1E38
	DW    0x1A
	DW    0x0
	DW    0xAC2
	DW    0x55
	DW    0x241C
	DW    0x804
	DW    0x0
	DW    0xA00
	DW    0x3112
	DW    0x50
	DW    0x0
	DW    0x414
	DW    0x400
	DW    0x100
	DW    0x3E
	DW    0x18C6
	DW    0x1C90
	DW    0x1B0
	DW    0xF36
	DW    0x0
	DW    0xA00
	DW    0x300
	DW    0x3F3E
	DW    0x1136
	DW    0x209C
	DW    0x1D01
	DW    0x7F
	DW    0x2081
	DW    0x3FC0
	DW    0x1F7F
	DW    0x2F06
	DW    0x1946
	DW    0x1F81
	DW    0x3F87
	DW    0x3E3
	DW    0x43
	DW    0x20
	DW    0x2004
	DW    0x3C00
	DW    0x1438
	DW    0xC7F
	DW    0x1F02
	DW    0x78
	DW    0x2200
	DW    0x3C00
	DW    0x1C78
	DW    0x3E08
	DW    0x1008
	DW    0x3E20
	DW    0x1E1C
	DW    0x1E44
	DW    0x44
	DW    0x400
	DW    0x408
GLCD_ZEICHEN_5x7
	GLOBAL GLCD_ZEICHEN_5x7
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcJA+0
			;	// 1. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp1[zeichen]);
	MOVF  _LcJA+0,W
	MOVWF _LcJA+1
	CLRF  _LcJA+2
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;
			;	// 2. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp2[zeichen]);
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  _LcJA+2
	MOVLW .128
	ADDWF _LcJA+0,W
	MOVWF _LcJA+1
	BTFSC 0x03,Carry
	INCF  _LcJA+2,1
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;
			;	// 3. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp3[zeichen]);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcJA+2
	MOVF  _LcJA+0,W
	MOVWF _LcJA+1
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;
			;	// 4. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp4[zeichen]);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcJA+2
	MOVLW .128
	ADDWF _LcJA+0,W
	MOVWF _LcJA+1
	BTFSC 0x03,Carry
	INCF  _LcJA+2,1
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;
			;	// 5. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(TabZeichensatz5x7_sp5[zeichen]);
	MOVLW .2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF _LcJA+2
	MOVF  _LcJA+0,W
	MOVWF _LcJA+1
	CALL  _const1
	CALL  GLCD_DATA_ZEICHEN
			;
			;	// 6. Spalte des Zeichens
			;	GLCD_DATA_ZEICHEN(0);
	MOVLW .0
	GOTO  GLCD_DATA_ZEICHEN
			;}

	END


; *** KEY INFO ***

; 0x0163 P0   47 word(s)  2 % : GLCD_ZEICHEN_5x7
; 0x0001 P0  354 word(s) 17 % : _const1

; RAM usage: 29 bytes (3 local), 339 bytes free
; Maximum call level: 1
;  Codepage 0 has  402 word(s) :  19 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 402 code words (4 %)
